### Function

# FwupdPlugin input_stream_read_byte_array

since: 2.0.0

#### Declaration [src]

    GByteArray*
    fu_input_stream_read_byte_array (
      GInputStream* stream,
      gsize offset,
      gsize count,
      FuProgress* progress,
      GError** error
    )

#### Description [src]

Read a byte array from a stream in a safe way.

NOTE: The returned buffer may be smaller than `count`!

Available since: 2.0.0

#### Parameters

`stream`

  Type: `GInputStream`

  A `GInputStream`.

  The data is owned by the caller of the function.

`offset`

  Type: `gsize`

  Offset in bytes into `stream` to copy from.

`count`

  Type: `gsize`

  Maximum number of bytes to read.

`progress`

  Type: `FuProgress`

  An optional `FuProgress`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guint8`

Buffer.

The caller of the function takes ownership of the data, and is responsible for freeing it.